#pragma HeapMin   10000
#pragma StackSize 50000

#include "std.h"
#include "megatyp.h"
#include "megacad.h"
/*Globale Variablen**********************************************************************/
uchar	laygrp[256];				// Platz fr die Layer und Gruppen Bits
uchar	count_i,count_j;		// Platz fr die Zhlervariablen
char	edta[32000];				// Puffer fr variable Daten (Schraffur, Polylines usw.)
/*Funktionen*****************************************************************************/
short ChangePid(void *argptr)	// *argprt bergabe von zeiger auf elmentstructur
{
  char      buf1[255];		// Platz fr Textzwischenspeicher
  char      buf2[255];		// Platz fr Textzwischenspeicher
  short     but;					// Platz fr Zhler und Schalter
	t_entity  *p_ent;				// Platz fr Zeiger auf Gebilde-Struktur (als erster Aufruf Entityloop notwendig!!!)
	uchar     *p_lay;				// Platz fr Zeiger auf Layernummer
	uchar     *p_grp;				// Platz fr Zeiger auf Gruppennummer
	
  p_ent  = argptr;						//init von Zeiger auf Gebilde-Struktur
	p_lay  = &p_ent->attr.lay;	//init von Zeiger auf Layernummer
	p_grp  = &p_ent->attr.grp;	//init von Zeiger auf Gruppennummer

	if(*p_lay == count_i)						// wenn Layernummer = Schleifenzhler ist ->
	{																// dann
	  if(laygrp[*p_grp] & GRP_ON)		// Teste ob die Gruppe des Elementes eingeschalten ist
	  {															// wenn ja dann
			*p_lay = count_j;						// weise Element-Attribut neue Layernummer zu 
			ExChangeEntity(p_ent,NULL);	// Element neu speichern,NULL(t_mat44) - die rumliche Lage bleibt erhalten 
	  }
	}
  return(CONTINUE_LOOP);					// Rcksprung zu Aufruffunktion - Schleife fortfhren
}
/*Hauptprogramm********************************************************/
short MegaMain(	char *filename, char *args )
{
  t_laygrp	lay;						// Platz fr die Layer Namen
	t_entity	ent;						// Platz fr Structur vom Typ t_entity
  ulong			filter;					// Platz fr Filter-Bits
	int				delta,summe_d;	// Platz fr Eingabe-Variable
	short			but,lay_a,lay_n;// Platz fr Schalter
  uchar			buf1[255];			// Platz fr Textzwischenspeicher
  uchar			buf2[255];			// Platz fr Textzwischenspeicher

	GetLayGrpBits(laygrp);		// die Layer/Gruppeneinstellungen holen
	GetLayerNames(&lay);			// die Layernamen holen

  Eingabe:
	sprintf(buf1,"verschieben der eingeschalteten Layer um:");
	sprintf(buf2,"100");
	but=StringInput(&buf1,&buf2,sizeof(buf2));
	if(but == TRUE)
	{
		delta=atoi(&buf2);
		if((delta > 255) || (delta < -255))
		{ 
			Message("Eingabe Fehler (-255 bis +255)","Verschiebung um maximal 255 Layer mglich",NULL,NULL,"WEITER",3); 
			goto Eingabe; // und zurck zur Eingabe
		}
		lay_a = Message("Alte Layernamen ersetzen durch:","Name bei beihalten, Leerzeichen, Ziel-Layernummer","=","Loeschen","Ziellayer",1);
		lay_n = Message("Neue Layernamen ersetzen durch:","Name bei beihalten, Leerzeichen, Ursprungsname   ","=","Loeschen","Ursprung ",1);
		for(count_i = 0 ; count_i<255; count_i++) 
		{
		  if(laygrp[count_i] & LAY_ON) // wenn Layer eingeschaltet, Verschiebelayer um "delta"
			{   
				summe_d = delta+count_i;
				if((summe_d <= 255) && (summe_d >= 0)) // Teste auf ber- und Unterlauf
				{
					count_j = summe_d;					// weise Zhler Betrag von Summe zu (Typ-Umwandlung int->uchar)
					sprintf(buf1,"Verschiebe Layer-Nummer (%d) -> (%d)",count_i,count_j);
					but = Message(buf1,lay.names[count_i],"OK","NEIN","ABBRUCH",1);
					if(but == 3) break;					// Schleife abbrechen
					if(but == 1)								// Verschiebung ausfhren
					{	
						switch(lay_n)
						{
							case 3 : sprintf(lay.names[count_j],lay.names[count_i]); break;	// verschiebe Alten- nach Neuen-Layernamen
							case 2 : sprintf(lay.names[count_j],""); break;									// lsche Ziel-Layernamen
						}
						switch(lay_a)
						{
							case 3 : sprintf(lay.names[count_i],"->(%d)",count_j); break;		// Altenlayernamen mit Ziellayer fllen
							case 2 : sprintf(lay.names[count_i],""); break;									// Altenlayernamen lschen
						}						 
						SetLayerNames(&lay);			// Layernamen in Zeichnung schreiben
						filter = 0xffffffff;			// Selektionskriterium -> alle Elemente erlaubt
						EntityLoop(filter,filter,ChangePid,&ent,&edta,NULL,sizeof(edta)); // Schleife ber alle Elemente, ecs=NULL - Rumlichelage bleibt
    				savecount();							// letzer Aufruf bei Eintragungen von Gebilden (Redro/Undo)
					}
				}
				else													// Fehlermeldung Test ber- Unterlauf
				{
					sprintf(buf1,"Von Layer (%d) -> Layer (%d) nicht mglich!!!",count_i,summe_d);
					but = Message("Verschiebe Fehler (Ziel-Layer < 0 oder > 255)",buf1,"WEITER",NULL,"ABBRUCH",1);
					if(but == 3) break;					// Schleife abbrechen
				}
			}
		}
  }
	return(0);	// Rcksprung zu Megacad
}
/*ENDE**********************************************************************/
